=== debian/changelog ===
ecflow (4.9.0-3) unstable; urgency=medium

  * Temporarily drop slurm dependency that is blocking ecflow

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 21 May 2018 07:31:42 +0100

ecflow (4.9.0-2) unstable; urgency=medium

  * Patch for mips* FTBFS from James Cowgill. Closes: #875461

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 18 Apr 2018 13:41:58 +0100

ecflow (4.9.0-1) unstable; urgency=medium

  * New upstream release
  * Renamed: ecflow_logsvr -> ecflow_logserver
  * gcc7-fixes.patch upstream
  * logserver patch now obsolete
  * Standards-Version: 4.1.4

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 09 Apr 2018 10:05:09 +0100
